package info.bayro.baFwk.datatypes;

import java.math.BigDecimal;

import info.bayro.baFwk.exception.InvalidValueException;
import info.bayro.baFwk.valueObject.ValueDescriptor;
import info.bayro.baFwk.valueObject.ValueFieldType;
import info.bayro.baFwk.valueObject.ValueGlobals;


@ValueDescriptor(maxSize = 10, fieldDigits = 2, fieldType = ValueFieldType._FIELD_SIGNED)
public class Betrag extends Number {

	private static final long serialVersionUID = -1212856394764947006L;

	private BigDecimal betrag;


	public Betrag(String betrag) throws InvalidValueException {
		try {
			this.setBetrag(new BigDecimal(betrag));
		} catch (NumberFormatException e) {
			throw new InvalidValueException(ValueGlobals._MSG_NUMBERFORMAT_EXCEPTION, betrag);
		}
	}


	public BigDecimal getBetrag() {
		return betrag;
	}


	public void setBetrag(BigDecimal betrag) {
		this.betrag = betrag;
	}


	@Override
	public double doubleValue() {
		return Double.valueOf(getBetrag().toString());
	}


	@Override
	public float floatValue() {
		return Float.valueOf(getBetrag().toString());
	}


	@Override
	public int intValue() {
		return Integer.valueOf(getBetrag().toString());
	}


	@Override
	public long longValue() {
		return Long.valueOf(getBetrag().toString());
	}


	@Override
	public String toString() {
		return betrag.toString();
	}

}
