package info.bayro.baFwk.datatypes;

import info.bayro.baFwk.exception.InvalidValueException;
import info.bayro.baFwk.valueObject.ValueDescriptor;
import info.bayro.baFwk.valueObject.ValueFieldType;
import info.bayro.baFwk.valueObject.ValueGlobals;


@ValueDescriptor(maxSize = 10, fieldType = ValueFieldType._FIELD_UNSIGNED)
public class KundenNummer extends Number {

	private static final long serialVersionUID = 411873091434550561L;

	private Long nrKunde;


	public KundenNummer(String nrKunde) throws InvalidValueException {
		try {
			this.setNrKunde(Long.valueOf(nrKunde));
		} catch (NumberFormatException e) {
			throw new InvalidValueException(ValueGlobals._MSG_NUMBERFORMAT_EXCEPTION, nrKunde);
		}
	}


	public Long getNrKunde() {
		return nrKunde;
	}


	public void setNrKunde(Long nrKunde) {
		this.nrKunde = nrKunde;
	}


	@Override
	public String toString() {
		return nrKunde.toString();
	}


	@Override
	public double doubleValue() {
		return Double.valueOf(nrKunde);
	}


	@Override
	public float floatValue() {
		return Float.valueOf(nrKunde);
	}


	@Override
	public int intValue() {
		return Integer.valueOf(nrKunde.toString());
	}


	@Override
	public long longValue() {
		return nrKunde;
	}

}
