package info.bayro.baFwk.gui;

import info.bayro.baFwk.guiElement.EPanel;
import info.bayro.baFwk.guiElement.ExtendedElement;

import java.awt.Component;
import java.util.Observable;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JViewport;


public abstract class EView extends ExtendedElement {

	protected EEventHandle eEventHandle;
	protected DataContainer dataContainer;


	public void onStart(EEventHandle eEventHandle, DataContainer dataContainer) {
		this.eEventHandle = eEventHandle;
		
		this.dataContainer = dataContainer;
		dataContainer.addObserver(this);

		jComponent = initView().getJComponent();
		assignActionListener(jComponent);
		
		runMediator();
	}


	private void assignActionListener(JComponent jComponent) {
		Component[] components = jComponent.getComponents();

		for (Component component : components) {
			if (component instanceof JPanel) {
				assignActionListener((JComponent) component);
			}

			if (component instanceof JScrollPane) {
				assignActionListener((JComponent) component);
			}

			if (component instanceof JViewport) {
				assignActionListener((JComponent) component);
			}

			if (component instanceof JButton) {
				((JButton) component).addActionListener(eEventHandle);
			}

			if (component instanceof JTable) {
				// ((JTable) component).getSelectionModel().addListSelectionListener(eEventHandle);
			}
		}

	}


	@Override
	protected void init() {}


	protected abstract EPanel initView();


	protected void runMediator() {}


	@Override
	public void update(Observable observable, Object msg) {

		if (observable.getClass().equals(dataContainer.getClass())) {
			runMediator();
		}
	}

}