package info.bayro.baFwk.gui;

import info.bayro.baFwk.exception.EExceptionHandle;
import info.bayro.baFwk.exception.ProcessingException;

import javax.swing.JComponent;

import org.apache.log4j.Logger;


public abstract class EViewFactory {

	protected EFrame eFrame;
	public final Logger log = Logger.getLogger(this.getClass());


	public EViewFactory(EFrame eFrame) {
		this.eFrame = eFrame;
	}


	public abstract void createView(String id, DataSelector ds);


	public void cancelView() {
		if (log.isTraceEnabled()) {
			log.trace("cancel the current view!");
		}

		eFrame.delCurrentComponent();
	}


	protected JComponent createView(EView eView, EEventHandle eEventHandle,
			ECommandHandle eCommandHandle, DataSelector ds) {
		if (log.isTraceEnabled()) {
			log.trace("create a new view");
		}

		try {
			eCommandHandle.onStart(ds);
			DataContainer dataContainer = eCommandHandle.getDataContainer();

			eEventHandle.setCommandHandle(eCommandHandle);
			eEventHandle.setViewFactoryRef(this);
			eEventHandle.onStart(ds);

			eView.onStart(eEventHandle, dataContainer);

			return eView.getJComponent();
			
		} catch (ProcessingException e) {
			EExceptionHandle.handleProcessingException(e);
		}

		return null;
	}

}