package info.bayro.baFwk.guiElement;

import java.util.Vector;

import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;


public class ETableModel extends AbstractTableModel {

	private static final long serialVersionUID = 4279520505667961395L;

	private Vector<Object[]> rows;
	private Vector<String> columns;
	private Vector<TableModelListener> listeners;

	private String command;


	public ETableModel() {
		rows = new Vector<Object[]>();
		columns = new Vector<String>();
		listeners = new Vector<TableModelListener>();
	}


	public String getColumnName(int index) {
		return columns.get(index);
	}


	public void addColumn(String name) {
		columns.add(name);
	}


	public Object getValueAt(int row, int col) {
		if (rows.get(row) != null && rows.get(row)[col] != null) {
			return rows.get(row)[col];
		} else {
			return null;
		}
	}
	
	public void removeAllRows(){
		rows.clear();
	}


	public int getColumnCount() {
		return columns.size();
	}


	public int getRowCount() {
		return rows.size();
	}


	public boolean isCellEditable(int rowIndex, int columnIndex) {
		return false;
	}


	public void addTableModelListener(TableModelListener l) {
		listeners.add(l);
	}


	public void removeTableModelListener(TableModelListener l) {
		listeners.remove(l);
	}


	public void removeRow(int index) {
		rows.remove(index);

		TableModelEvent e = new TableModelEvent(this, TableModelEvent.ALL_COLUMNS, TableModelEvent.DELETE);
		for (TableModelListener listener : listeners) {
			listener.tableChanged(e);
		}
	}


	public void addData(Object[] row) {
		rows.add(row);

		TableModelEvent e = new TableModelEvent(this, TableModelEvent.ALL_COLUMNS, TableModelEvent.INSERT);
		for (TableModelListener listener : listeners) {
			listener.tableChanged(e);
		}
	}


	public void setActionCommand(String command) {
		this.command = command;
	}


	public String getActionCommand() {
		return command;
	}

}