package info.bayro.baFwk.guiElement.listener;

import java.math.BigDecimal;

import javax.swing.InputVerifier;
import javax.swing.JComponent;
import javax.swing.JTextField;

import info.bayro.baFwk.guiElement.EElementGlobals;
import info.bayro.baFwk.valueObject.ValueFieldType;


public class ETextFieldVerifier extends InputVerifier {

	private ValueFieldType fieldType = ValueFieldType._FIELD_ALPHANUM;
	private int fieldSize;
	private int digits;


	public ETextFieldVerifier(ValueFieldType fieldType, int fieldSize, int digits) {
		this.fieldType = fieldType;
		this.fieldSize = fieldSize;
		this.digits = digits;
	}


	@Override
	public boolean verify(JComponent arg0) {
		String input = ((JTextField) arg0).getText().trim();

		if (!input.isEmpty()) {

			if (fieldType == ValueFieldType._FIELD_SIGNED) {

				input = input.replace("+", "").replace("-", "");
				String[] split = input.split(",");

				if (split[0].length() > fieldSize) {
					setRed((JTextField) arg0);
					return false;
				}

				if (digits == 0 && split.length > 1) {
					setRed((JTextField) arg0);
					return false;
				}

				if (digits > 0) {
					if (split.length > 2) {
						setRed((JTextField) arg0);
						return false;
					}

					if (split.length == 2 && split[1].length() > digits) {
						setRed((JTextField) arg0);
						return false;
					}
				}

				try {
					input = input.replace(",", ".");
					new BigDecimal(input);

					setWhite((JTextField) arg0);

					return true;
				} catch (NumberFormatException e) {
					setRed((JTextField) arg0);
					return false;
				}

			} else {
				setWhite((JTextField) arg0);
				return true;
			}

		} else {
			setWhite((JTextField) arg0);
			return true;
		}
	}


	private void setRed(JTextField jTextField) {
		jTextField.setBackground(EElementGlobals._COLOR_RED);
	}


	private void setWhite(JTextField jTextField) {
		if (jTextField.isEditable()) {
			jTextField.setBackground(EElementGlobals._COLOR_WHITE);
		}
	}

}