package info.bayro.baFwk.junit.valueObject;

import info.bayro.baFwk.datatypes.Betrag;
import info.bayro.baFwk.datatypes.KundenNummer;
import info.bayro.baFwk.exception.InvalidValueException;
import info.bayro.baFwk.valueObject.UpdateMsg;
import info.bayro.baFwk.valueObject.ValueChecker;
import info.bayro.baFwk.valueObject.ValueDescriptor;
import info.bayro.baFwk.valueObject.ValueObject;


public class TestVO extends ValueObject {

	private KundenNummer nrKunde;
	private Betrag betrKaufpreis;

	@ValueDescriptor(maxSize = 15)
	private String bezStr;

	private String bezName;


	public String getBezStr() {
		return bezStr;
	}


	public void setBezStr(String bezStr) throws InvalidValueException {
		if (ValueChecker.checkValue(this, "bezStr", bezStr)) {
			this.bezStr = bezStr;
			fireUpdate(new UpdateMsg("bezStr", bezStr));
		}
	}


	public KundenNummer getNrKunde() {
		return nrKunde;
	}


	public void setNrKunde(KundenNummer nrKunde) throws InvalidValueException {
		if (ValueChecker.checkValue(this, "nrKunde", nrKunde)) {
			this.nrKunde = nrKunde;
			fireUpdate(new UpdateMsg("nrKunde", nrKunde.toString()));
		}
	}


	public Betrag getBetrKaufpreis() {
		return betrKaufpreis;
	}


	public void setBetrKaufpreis(Betrag betrKaufpreis) throws InvalidValueException {
		if (ValueChecker.checkValue(this, "betrKaufpreis", betrKaufpreis)) {
			this.betrKaufpreis = betrKaufpreis;
			fireUpdate(new UpdateMsg("betrKaufpreis", betrKaufpreis.toString()));
		}
	}


	public String getBezName() {
		return bezName;
	}


	public void setBezName(String bezName) throws InvalidValueException {
		if (ValueChecker.checkValue(this, "bezName", bezName)) {
			this.bezName = bezName;
			fireUpdate(new UpdateMsg("bezName", bezName.toString()));
		}
	}

}
